/* GCC */
#include <fstream>
#include <vector>
#include <set>

using namespace std;

const unsigned char LU = 0, RU = 1, LD = 2, RD = 3;
typedef unsigned short shize_t;

struct pos
{
    pos(void) {};
    pos(shize_t y, shize_t x, char c) : ver(y), hor(x), corner(c) {}
    shize_t ver;
    shize_t hor;
    char corner;
};

struct Comp
{
    bool operator()(const pair<size_t, pos>& p1, const pair<size_t, pos>& p2)
    {
        if(p1.first < p2.first)
            return true;
        else if(p1.first == p2.first)
        {
            if(p1.second.ver < p2.second.ver)
                return true;
            else if(p1.second.ver == p2.second.ver)
            {
                if(p1.second.hor < p2.second.hor)
                    return true;
                else if(p1.second.hor == p2.second.hor)
                    return p1.second.corner < p2.second.corner;
                return false;
            }
            return false;
        }
        return false;
    }
};

size_t d[250][250][4];

int main(void)
{
    shize_t m, n;
    ifstream in("school.in");
    in >> m >> n;
    vector<vector<size_t> > times(n, vector<size_t>(m));
    for(shize_t i = 0; i < n; ++i)
        for(shize_t j = 0; j < m; ++j)
        {
            in >> times[i][j];
            d[i][j][LD] = d[i][j][LU] = d[i][j][RD] = d[i][j][RU] = 1000000000;
        }
    in.close();
    set<pair<size_t, pos>, Comp> s;
    s.insert(make_pair(0, pos(n-1, 0, LD)));
    d[n-1][0][LD] = 0;
    pair<size_t, pos> cur;
    set<pair<size_t, pos> >::iterator it;
    size_t cur_t, tmp;
    while(!s.empty())
    {
        cur = *s.begin(), cur_t = times[cur.second.ver][cur.second.hor];
        s.erase(s.begin());
        switch(cur.second.corner)
        {
        case LU:
            tmp = 1;
            if((cur.first/cur_t)&1)
                tmp += (cur.first/cur_t+1)*cur_t-cur.first;
            if(d[cur.second.ver][cur.second.hor][LU] + tmp < d[cur.second.ver][cur.second.hor][RU])
            {
                it = s.find(make_pair(d[cur.second.ver][cur.second.hor][RU], pos(cur.second.ver, cur.second.hor, RU)));
                if(it != s.end())
                    s.erase(it);
                d[cur.second.ver][cur.second.hor][RU] = d[cur.second.ver][cur.second.hor][LU] + tmp;
                s.insert(make_pair(d[cur.second.ver][cur.second.hor][RU], pos(cur.second.ver, cur.second.hor, RU)));
            }
            tmp = 1;
            if(((cur.first/cur_t)&1) == 0)
                tmp += (cur.first/cur_t+1)*cur_t-cur.first;
            if(d[cur.second.ver][cur.second.hor][LU] + tmp < d[cur.second.ver][cur.second.hor][LD])
            {
                it = s.find(make_pair(d[cur.second.ver][cur.second.hor][LD], pos(cur.second.ver, cur.second.hor, LD)));
                if(it != s.end())
                    s.erase(it);
                d[cur.second.ver][cur.second.hor][LD] = d[cur.second.ver][cur.second.hor][LU] + tmp;
                s.insert(make_pair(d[cur.second.ver][cur.second.hor][LD], pos(cur.second.ver, cur.second.hor, LD)));
            }
            break;
        case RU:
            tmp = 1;
            if((cur.first/cur_t)&1)
                tmp += (cur.first/cur_t+1)*cur_t-cur.first;
            if(d[cur.second.ver][cur.second.hor][RU] + tmp < d[cur.second.ver][cur.second.hor][LU])
            {
                it = s.find(make_pair(d[cur.second.ver][cur.second.hor][LU], pos(cur.second.ver, cur.second.hor, LU)));
                if(it != s.end())
                    s.erase(it);
                d[cur.second.ver][cur.second.hor][LU] = d[cur.second.ver][cur.second.hor][RU] + tmp;
                s.insert(make_pair(d[cur.second.ver][cur.second.hor][LU], pos(cur.second.ver, cur.second.hor, LU)));
            }
            tmp = 1;
            if(((cur.first/cur_t)&1) == 0)
                tmp += (cur.first/cur_t+1)*cur_t-cur.first;
            if(d[cur.second.ver][cur.second.hor][RU] + tmp < d[cur.second.ver][cur.second.hor][RD])
            {
                it = s.find(make_pair(d[cur.second.ver][cur.second.hor][RD], pos(cur.second.ver, cur.second.hor, RD)));
                if(it != s.end())
                    s.erase(it);
                d[cur.second.ver][cur.second.hor][RD] = d[cur.second.ver][cur.second.hor][RU] + tmp;
                s.insert(make_pair(d[cur.second.ver][cur.second.hor][RD], pos(cur.second.ver, cur.second.hor, RD)));
            }
            break;
        case LD:
            tmp = 1;
            if((cur.first/cur_t)&1)
                tmp += (cur.first/cur_t+1)*cur_t-cur.first;
            if(d[cur.second.ver][cur.second.hor][LD] + tmp < d[cur.second.ver][cur.second.hor][RD])
            {
                it = s.find(make_pair(d[cur.second.ver][cur.second.hor][RD], pos(cur.second.ver, cur.second.hor, RD)));
                if(it != s.end())
                    s.erase(it);
                d[cur.second.ver][cur.second.hor][RD] = d[cur.second.ver][cur.second.hor][LD] + tmp;
                s.insert(make_pair(d[cur.second.ver][cur.second.hor][RD], pos(cur.second.ver, cur.second.hor, RD)));
            }
            tmp = 1;
            if(((cur.first/cur_t)&1) == 0)
                tmp += (cur.first/cur_t+1)*cur_t-cur.first;
            if(d[cur.second.ver][cur.second.hor][LD] + tmp < d[cur.second.ver][cur.second.hor][LU])
            {
                it = s.find(make_pair(d[cur.second.ver][cur.second.hor][LU], pos(cur.second.ver, cur.second.hor, LU)));
                if(it != s.end())
                    s.erase(it);
                d[cur.second.ver][cur.second.hor][LU] = d[cur.second.ver][cur.second.hor][LD] + tmp;
                s.insert(make_pair(d[cur.second.ver][cur.second.hor][LU], pos(cur.second.ver, cur.second.hor, LU)));
            }
            break;
        case RD:
            tmp = 1;
            if((cur.first/cur_t)&1)
                tmp += (cur.first/cur_t+1)*cur_t-cur.first;
            if(d[cur.second.ver][cur.second.hor][RD] + tmp < d[cur.second.ver][cur.second.hor][LD])
            {
                it = s.find(make_pair(d[cur.second.ver][cur.second.hor][LD], pos(cur.second.ver, cur.second.hor, LD)));
                if(it != s.end())
                    s.erase(it);
                d[cur.second.ver][cur.second.hor][LD] = d[cur.second.ver][cur.second.hor][RD] + tmp;
                s.insert(make_pair(d[cur.second.ver][cur.second.hor][LD], pos(cur.second.ver, cur.second.hor, LD)));
            }
            tmp = 1;
            if(((cur.first/cur_t)&1) == 0)
                tmp += (cur.first/cur_t+1)*cur_t-cur.first;
            if(d[cur.second.ver][cur.second.hor][RD] + tmp < d[cur.second.ver][cur.second.hor][RU])
            {
                it = s.find(make_pair(d[cur.second.ver][cur.second.hor][RU], pos(cur.second.ver, cur.second.hor, RU)));
                if(it != s.end())
                    s.erase(it);
                d[cur.second.ver][cur.second.hor][RU] = d[cur.second.ver][cur.second.hor][RD] + tmp;
                s.insert(make_pair(d[cur.second.ver][cur.second.hor][RU], pos(cur.second.ver, cur.second.hor, RU)));
            }
            break;
        }
        if(cur.second.ver > 0 && (cur.second.corner == LU || cur.second.corner == RU))
        {
            unsigned char dir = (cur.second.corner == LU ? LD : RD);
            if(cur.first + 60 < d[cur.second.ver-1][cur.second.hor][dir])
            {
                it = s.find(make_pair(d[cur.second.ver-1][cur.second.hor][dir], pos(cur.second.ver-1, cur.second.hor, dir)));
                if(it != s.end())
                    s.erase(it);
                d[cur.second.ver-1][cur.second.hor][dir] = cur.first + 60;
                s.insert(make_pair(d[cur.second.ver-1][cur.second.hor][dir], pos(cur.second.ver-1, cur.second.hor, dir)));
            }
        }
        if(cur.second.ver < n-1 && (cur.second.corner == LD || cur.second.corner == RD))
        {
            unsigned char dir = (cur.second.corner == LD ? LU : RU);
            if(cur.first + 60 < d[cur.second.ver+1][cur.second.hor][dir])
            {
                it = s.find(make_pair(d[cur.second.ver+1][cur.second.hor][dir], pos(cur.second.ver+1, cur.second.hor, dir)));
                if(it != s.end())
                    s.erase(it);
                d[cur.second.ver+1][cur.second.hor][dir] = cur.first + 60;
                s.insert(make_pair(d[cur.second.ver+1][cur.second.hor][dir], pos(cur.second.ver+1, cur.second.hor, dir)));
            }
        }
        if(cur.second.hor > 0 && (cur.second.corner == LU || cur.second.corner == LD))
        {
            unsigned char dir = (cur.second.corner == LU ? RU : RD);
            if(cur.first + 60 < d[cur.second.ver][cur.second.hor-1][dir])
            {
                it = s.find(make_pair(d[cur.second.ver][cur.second.hor-1][dir], pos(cur.second.ver, cur.second.hor-1, dir)));
                if(it != s.end())
                    s.erase(it);
                d[cur.second.ver][cur.second.hor-1][dir] = cur.first + 60;
                s.insert(make_pair(d[cur.second.ver][cur.second.hor-1][dir], pos(cur.second.ver, cur.second.hor-1, dir)));
            }
        }
        if(cur.second.hor < m-1 && (cur.second.corner == RU || cur.second.corner == RD))
        {
            unsigned char dir = (cur.second.corner == RU ? LU : LD);
            if(cur.first + 60 < d[cur.second.ver][cur.second.hor+1][dir])
            {
                it = s.find(make_pair(d[cur.second.ver][cur.second.hor+1][dir], pos(cur.second.ver, cur.second.hor+1, dir)));
                if(it != s.end())
                    s.erase(it);
                d[cur.second.ver][cur.second.hor+1][dir] = cur.first + 60;
                s.insert(make_pair(d[cur.second.ver][cur.second.hor+1][dir], pos(cur.second.ver, cur.second.hor+1, dir)));
            }
        }
    }
    ofstream out("school.out");
    out << d[0][m-1][RU] << '\n';
    out.close();
    return 0;
}
